-- name: \\#41eb23\\Yoshi V2.2 (probably the latest version)
-- description: You can play as yoshi with the voice \n\Model by CheezyNacho \n\Custom voice resource by SMS Alfredo\n\\#00c8ff\\yoshi voice programing by Lucho_Gamer \n\\#ff0000\\Yoshi Model source by XxCmbRxX \n\\#ff0000\\Fixed Voice Command by JairoThePlumber 

E_MODEL_yoshi_PLAYER = smlua_model_util_get_id("yoshi_player_geo")

ACT_FLUTTER = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_FLUTTER_FREEFALL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)

local yoshi_model = true
gPlayerSyncTable[0].heMario = true
gPlayerSyncTable[0].yoshivoicecheck = 1

ANGLE_QUEUE_SIZE = 9

gEventTable = {}

gStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gStateExtras[i] = {}
    local m = gMarioStates[i]
    local e = gStateExtras[i]
    e.canflutter = true
    e.angleDeltaQueue = {}
    for j = 0, (ANGLE_QUEUE_SIZE - 1) do e.angleDeltaQueue[j] = 0 end
    e.animFrame = 0
end

function act_flutter(m)
    local e = gStateExtras[m.playerIndex]

    common_air_action_step(m, ACT_JUMP_LAND, MARIO_ANIM_RUNNING_UNUSED, AIR_STEP_NONE)

    play_sound(SOUND_ACTION_TWIRL, m.marioObj.header.gfx.cameraToObject)

    if m.actionTimer == 0 then
        m.actionState = m.actionArg
        play_sound(SOUND_GENERAL_yoshi_TALK, m.marioObj.header.gfx.cameraToObject)
    end

    m.vel.y = m.actionTimer / 2
    if m.prevAction ~= ACT_TRIPLE_JUMP then  
        if m.actionTimer > 30 or (m.controller.buttonDown & A_BUTTON) == 0 then
            set_mario_action(m, ACT_FREEFALL, 0)
        end
    else
        if m.actionTimer > 30 or (m.controller.buttonDown & A_BUTTON) == 0 then
            set_mario_action(m, ACT_FLUTTER_FREEFALL, 0)
        end
    end

    set_mario_animation(m, MARIO_ANIM_RUNNING_UNUSED)
    set_anim_to_frame(m, e.animFrame)
    e.animFrame = e.animFrame + 10
    if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
        e.animFrame = e.animFrame - m.marioObj.header.gfx.animInfo.curAnim.loopEnd
    end

    m.actionTimer = m.actionTimer + 1
    return 0
end

function act_flutter_freefall(m)
    local e = gStateExtras[m.playerIndex]

    common_air_action_step(m, ACT_TRIPLE_JUMP_LAND, MARIO_ANIM_FORWARD_SPINNING, AIR_STEP_NONE)
end

function yoshi_command(msg)
    if msg == 'on' then
        gPlayerSyncTable[0].heMario = true
        yoshi_model = true
		gPlayerSyncTable[0].yoshivoicecheck = 1
        djui_chat_message_create('The \\#71bf47\\Yoshi \\#71bf47\\model and voice is on')
        return true
    elseif msg == "off" then
        gPlayerSyncTable[0].heMario = false
        yoshi_model = false
		gPlayerSyncTable[0].yoshivoicecheck = 0
        djui_chat_message_create('The \\#71bf47\\Yoshi \\#ff0000\\model and voice is off')
        return true
    end
    return false
end

function mario_update_local(m)
    if yoshi_model == true then
        gPlayerSyncTable[0].modelId = E_MODEL_yoshi_PLAYER
    end
    if yoshi_model == false then
		gPlayerSyncTable[0].modelId = nil
	end
end

function mario_update(m)
    local e = gStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    local np = gNetworkPlayers[m.playerIndex]

    if yoshi == true and gMarioStates[0].character.type == 0 then

        if e.canflutter == true then
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 and m.actionTimer > 0 then
                if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_LONG_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_FREEFALL then
                    set_mario_action(m, ACT_FLUTTER, 0)
                    e.canflutter = false
                end
            end
        end
        if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_LONG_JUMP or  m.action == ACT_SIDE_FLIP or m.action == ACT_FREEFALL or m.action == ACT_BACKFLIP then
            m.actionTimer = m.actionTimer + 1
        end
        if m.action == ACT_JUMP_LAND or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP_LAND or m.action == ACT_IDLE or m.action == ACT_WALKING then
            e.canflutter = true
        end

        --No Walljump from flutter
        if e.canflutter == false and m.action == ACT_AIR_HIT_WALL then
            set_mario_action(m, ACT_BUTT_SLIDE_AIR, 0)
        end
    end

    if s.heMario then
        np.overrideModelIndex = 0
    else
        np.overrideModelIndex = np.modelIndex
    end

    if m.playerIndex == 0 then
        mario_update_local(m)
    end

    if gPlayerSyncTable[m.playerIndex].modelId ~= nil then
        obj_set_model_extended(m.marioObj, gPlayerSyncTable[m.playerIndex].modelId)
    end

    if gPlayerSyncTable[0].modelId ~= E_MODEL_yoshi_PLAYER then return end
end

function mario_on_set_action(m)
    if yoshi == true and gMarioStates[0].character.type == 0 then

        if m.action == ACT_DIVE and m.prevAction ~= ACT_TRIPLE_JUMP and (m.marioObj.collidedObjInteractTypes & INTERACT_GRABBABLE) == 0 then
            set_mario_action(m, ACT_JUMP_KICK, 0)
            if m.forwardVel > 0 then
                m.forwardVel = m.forwardVel -15
            end
        end
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)

hook_mario_action(ACT_FLUTTER,     { every_frame = act_flutter })
hook_mario_action(ACT_FLUTTER_FREEFALL,     { every_frame = act_flutter_freefall })

hook_chat_command('yoshi_v', "[\\#ffffff\\on\\#ffffff\\|\\#ffffff\\off\\#ffffff\\] turn \\#ffffff\\the Yoshi model\\#ffffff\\ \\#ffffff\\on \\#ffffff\\or \\#ffffff\\off", yoshi_command)

for i=0,(MAX_PLAYERS-1) do
    local s = gPlayerSyncTable[i]
    s.heMario = false
end
--From here on this is all SMS Alfredo's custom voice resource

local function use_custom_voice(m)
	local yoshi_voice = gPlayerSyncTable[m.playerIndex].yoshivoicecheck
    return yoshi_voice == 1 --Put your condition here!
end

--How many snores the sleep-talk has, or rather, how long the sleep-talk lasts
--If you omit the sleep-talk you can ignore this
local SLEEP_TALK_SNORES = 8

--Define what actions play what voice clips
--If an action has more than one voice clip, put those clips inside a table
--CHAR_SOUND_SNORING3 requires two or three voice clips to work properly...
--but you can omit it if your character does not sleep-talk
local CUSTOM_VOICETABLE = {
    [CHAR_SOUND_ATTACKED] = {'Hurt 1.mp3', 'Hurt 2.mp3', 'Hurt 3.mp3'},
    [CHAR_SOUND_DOH] = 'oof 1.mp3',
    [CHAR_SOUND_DYING] = {'Dying 1.mp3', 'Dying 2.mp3'},
    [CHAR_SOUND_EEUH] = {'Slow Get up from Ledge 1.mp3',},
    [CHAR_SOUND_GAME_OVER] = {'Electrocuted.mp3', 'Thrown.mp3', 'Get Picked up.mp3', 'Squished.mp3'},
    [CHAR_SOUND_GROUND_POUND_WAH] = {'Ground Pound.mp3', 'Ground Pound 2.mp3',},
    [CHAR_SOUND_HAHA] = 'Long Jump.mp3',
    [CHAR_SOUND_HAHA_2] = 'Lands 1.mp3',
    [CHAR_SOUND_HELLO] = 'Quiet Mario.mp3',
    [CHAR_SOUND_HERE_WE_GO] = {'Star Get 1.mp3',},
    [CHAR_SOUND_HOOHOO] = 'Double Jump 1.mp3',
    [CHAR_SOUND_HRMM] = 'Grab Ledge 1.mp3',
    [CHAR_SOUND_IMA_TIRED] = 'Quiet Mario.mp3',
    [CHAR_SOUND_LETS_A_GO] = 'Yoshi.mp3',
    [CHAR_SOUND_MAMA_MIA] = 'Slow Get up from Ledge 3.mp3',
    [CHAR_SOUND_ON_FIRE] = {'Hurt in Lava 1.mp3',},
    [CHAR_SOUND_OOOF] = 'ooof 2.mp3',
    [CHAR_SOUND_OOOF2] = 'ooof 2.mp3',
    [CHAR_SOUND_PANTING] = {'Panting 1.mp3',},
    [CHAR_SOUND_PANTING_COLD] = 'Panting 1.mp3',
    [CHAR_SOUND_PRESS_START_TO_PLAY] = {'Triple Jump 1.mp3', 'Triple Jump 2.mp3'},
    [CHAR_SOUND_PUNCH_HOO] = {'Kick 1.mp3',},
    [CHAR_SOUND_PUNCH_WAH] = 'Punch 1.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'Punch 2.mp3',
    [CHAR_SOUND_SNORING1] = 'Sleeping 1.mp3',
    [CHAR_SOUND_SNORING2] = 'Sleeping 2.mp3',
    [CHAR_SOUND_SNORING3] = {'Sleeping 1.mp3', 'Sleeping 2.mp3'},
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'Throw Bowser 1.mp3', 'Throw Bowser 2.mp3'},
    [CHAR_SOUND_TWIRL_BOUNCE] = {'Triple Jump 5.mp3'},
    [CHAR_SOUND_UH] = 'Ledge Miss.mp3',
    [CHAR_SOUND_UH2] = {'Get up from Ledge.mp3',},
    [CHAR_SOUND_UH2_2] = 'Ledge Miss.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'Falling.mp3',
    [CHAR_SOUND_WAH2] = 'Kick 2.mp3',
    [CHAR_SOUND_WHOA] = 'Grab Ledge 1.mp3',
    [CHAR_SOUND_YAHOO] = {'Long Jump.mp3',},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Triple Jump 1.mp3', 'Long Jump.mp3'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'Jump 2.mp3', 'Jump 3.mp3', 'Jump 4.mp3'},
    [CHAR_SOUND_YAWNING] = 'Tired 2.mp3',
}

--Define the table of samples that will be used for each player
--Global so if multiple mods use this they won't create unneeded samples
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
gCustomVoiceSamples = {}
gCustomVoiceStream = nil

--Get the player's sample, stop whatever sound
--it's playing if it doesn't match the provided sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function stop_custom_character_sound(m, sound)
    local voice_sample = gCustomVoiceSamples[m.playerIndex]
    if voice_sample == nil or not voice_sample.loaded then
        return
    end

    audio_sample_stop(voice_sample)
    if voice_sample.file.relativePath:match('^.+/(.+)$') == sound then
        return voice_sample
    end
    audio_sample_destroy(voice_sample)
end

--Play a custom character's sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function play_custom_character_sound(m, voice)
    --Get sound, if it's a table, get a random entry from it
    local sound
    if type(voice) == "table" then
        sound = voice[math.random(#voice)]
    else
        sound = voice
    end
    if sound == nil then return 0 end

    --Get current sample and stop it
    local voice_sample = stop_custom_character_sound(m, sound)

    --If the new sound isn't a string, let's assume it's
    --a number to return to the character sound hook
    if type(sound) ~= "string" then
        return sound
    end

    --Load a new sample and play it! Don't make a new one if we don't need to
    if (m.area == nil or m.area.camera == nil) and m.playerIndex == 0 then
        if gCustomVoiceStream ~= nil then
            audio_stream_stop(gCustomVoiceStream)
            audio_stream_destroy(gCustomVoiceStream)
        end
        gCustomVoiceStream = audio_stream_load(sound)
        audio_stream_play(gCustomVoiceStream, true, 1)
    else
        if voice_sample == nil then
            voice_sample = audio_sample_load(sound)
        end
        audio_sample_play(voice_sample, m.pos, 1)

        gCustomVoiceSamples[m.playerIndex] = voice_sample
    end
    return 0
end

--Main character sound hook
--This hook is freely modifiable in case you want to make any specific exceptions
--- @param m MarioState
local function custom_character_sound(m, characterSound)
    if not use_custom_voice(m) then return end
    if characterSound == CHAR_SOUND_SNORING3 then return 0 end
    if characterSound == CHAR_SOUND_HAHA and m.hurtCounter > 0 then return 0 end

    local voice = CUSTOM_VOICETABLE[characterSound]
    if voice ~= nil then
        return play_custom_character_sound(m, voice)
    end
    return 0
end
hook_event(HOOK_CHARACTER_SOUND, custom_character_sound)

--Snoring logic for CHAR_SOUND_SNORING3 since we have to loop it manually
--This code won't activate on the Japanese version, due to MARIO_MARIO_SOUND_PLAYED not being set
local SNORE3_TABLE = CUSTOM_VOICETABLE[CHAR_SOUND_SNORING3]
local STARTING_SNORE = 46
local SLEEP_TALK_START = STARTING_SNORE + 49
local SLEEP_TALK_END = SLEEP_TALK_START + SLEEP_TALK_SNORES

--Main hook for snoring
--- @param m MarioState
local function custom_character_snore(m)
    if not use_custom_voice(m) then return end

    --Stop the snoring!
    if m.action ~= ACT_SLEEPING then
        if m.isSnoring > 0 then
            stop_custom_character_sound(m)
        end
        return

    --You're not in deep snoring
    elseif not (m.actionState == 2 and (m.flags & MARIO_MARIO_SOUND_PLAYED) ~= 0) then
        return
    end

    local animFrame = m.marioObj.header.gfx.animInfo.animFrame

    --Behavior for CHAR_SOUND_SNORING3
    if SNORE3_TABLE ~= nil and #SNORE3_TABLE >= 2 then
        --Exhale sound
        if animFrame == 2 and m.actionTimer < SLEEP_TALK_START then
            play_custom_character_sound(m, SNORE3_TABLE[2])

        --Inhale sound
        elseif animFrame == 25 then
            
            --Count up snores
            if #SNORE3_TABLE >= 3 then
                m.actionTimer = m.actionTimer + 1

                --End sleep-talk
                if m.actionTimer >= SLEEP_TALK_END then
                    m.actionTimer = STARTING_SNORE
                end
    
                --Enough snores? Start sleep-talk
                if m.actionTimer == SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[3])
                
                --Regular snoring
                elseif m.actionTimer < SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[1])
                end
            
            --Definitely regular snoring
            else
                play_custom_character_sound(m, SNORE3_TABLE[1])
            end
        end

    --No CHAR_SOUND_SNORING3, just use regular snoring
    elseif animFrame == 2 then
        play_character_sound(m, CHAR_SOUND_SNORING2)

    elseif animFrame == 25 then
        play_character_sound(m, CHAR_SOUND_SNORING1)
    end
end

hook_event(HOOK_MARIO_UPDATE, custom_character_snore)
